#include "MatrixResizeDialog.h"

MatrixResizeDialog::MatrixResizeDialog(QWidget *parent)
  : QDialog(parent),
    _prevRow(100),
    _prevCol(100)
{
    setupUi(this);

    _defaultRadio = rbMedium;

    rbMedium->setChecked(true);
    lblRows->setEnabled(false);
    lblColumns->setEnabled(false);
    leRows->setEnabled(false);
    leColumns->setEnabled(false);

    connect(buttonBox, SIGNAL(accepted()), this, SLOT(accepted()));
    connect(rbSmall, SIGNAL(clicked(bool)), this, SLOT(disableLineEdits(bool)));
    connect(rbMedium, SIGNAL(clicked(bool)), this, SLOT(disableLineEdits(bool)));
    connect(rbLarge, SIGNAL(clicked(bool)), this, SLOT(disableLineEdits(bool)));
    connect(rbCustom, SIGNAL(clicked(bool)), this, SLOT(enableLineEdits(bool)));
}

void MatrixResizeDialog::showEvent(QShowEvent *e)
{
    _defaultRadio->setChecked(true);
}

void MatrixResizeDialog::accepted()
{
    QRadioButton *currRadio = 0;
    int row = 100, col = 100;
    if(rbSmall->isChecked())
    {
        row = 50;
        col = 50;

        if(_defaultRadio != rbSmall)
        {
            _defaultRadio = rbSmall;
        }
    }
    else if(rbMedium->isChecked())
    {
        row = 100;
        col = 100;
        if(_defaultRadio != rbMedium)
            _defaultRadio = rbMedium;
    }
    else if(rbLarge->isChecked())
    {
        row = 1000;
        col = 1000;
        if(_defaultRadio != rbLarge)
            _defaultRadio = rbLarge;
    }
    else if(rbCustom->isChecked())
    {
        bool ok = false;
        row = leRows->text().toInt(&ok);
        if(not ok)
        {
            // do not emit a signal
            return;
        }

        col = leColumns->text().toInt(&ok);
        if(not ok)
        {
            // do not emit a signal
            return;
        }

        if(_defaultRadio != rbCustom)
            _defaultRadio = rbCustom;
    }

    // Make sure the signal doesn't get emitted if the row/column stayed the same
    if((_prevRow != row) or (_prevCol != col))
    {
        _prevRow = row;
        _prevCol = col;
        emit resize(row, col);
    }
}

void MatrixResizeDialog::enableLineEdits(bool checked)
{
    lblRows->setEnabled(true);
    lblColumns->setEnabled(true);
    leRows->setEnabled(true);
    leColumns->setEnabled(true);
}

void MatrixResizeDialog::disableLineEdits(bool checked)
{
    lblRows->setEnabled(false);
    lblColumns->setEnabled(false);
    leRows->setEnabled(false);
    leColumns->setEnabled(false);
}
