#ifndef MATRIX_RESIZE_DIALOG_H
#define MATRIX_RESIZE_DIALOG_H

#include <QDialog>
#include "ui_MatrixResizeDialog.h"

class MatrixResizeDialog : public QDialog, public Ui::dlgMatrixResize
{
    Q_OBJECT

    public:
        /// Constructor
        MatrixResizeDialog(QWidget *parent);

        /// Destructor
        virtual ~MatrixResizeDialog() {}

    protected:
        /// Method invoked whenever the form is shown
        virtual void showEvent(QShowEvent *e);

    signals:
        /// Method to notify that the form has been processed with resize data
        void resize(int row, int col);

    protected slots:
        /// Method invoked whenever the OK is pressed
        void accepted();

        /// Methods to enable/disable the QLineEdits
        void enableLineEdits(bool checked);
        void disableLineEdits(bool checked);

    private:
        int _prevRow;
        int _prevCol;
        QRadioButton *_defaultRadio;
};

#endif //MATRIX_RESIZE_DIALOG_H
